c    "Copyright 2009 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.


c  ...  viscous term from (Monaghan 1994;  J. Comp. Phys. 110. Formula 2.1b)
c
      
      subroutine vorticity_calc(i,j,dux,duy,duz)

      include 'common.3D'
   
      pmj_over_rhoi = pm(j)/rhop(i)
      
      curl3x_a(i)= curl3x_a(i)+duy*frzi*pmj_over_rhoi
      curl3x_b(i)= curl3x_b(i)+duz*fryi*pmj_over_rhoi
      curl3y_a(i)= curl3y_a(i)+duz*frxi*pmj_over_rhoi
      curl3y_b(i)= curl3y_b(i)+dux*frzi*pmj_over_rhoi
      curl3z_a(i)= curl3z_a(i)+dux*fryi*pmj_over_rhoi
      curl3z_b(i)= curl3z_b(i)+duy*frxi*pmj_over_rhoi

      pmi_over_rhoj = pm(i)/rhop(j)
      
      curl3x_a(j)= curl3x_a(j)+duy*frzj*pmi_over_rhoj
      curl3x_b(j)= curl3x_b(j)+duz*fryj*pmi_over_rhoj
      curl3y_a(j)= curl3y_a(j)+duz*frxj*pmi_over_rhoj
      curl3y_b(j)= curl3y_b(j)+dux*frzj*pmi_over_rhoj
      curl3z_a(j)= curl3z_a(j)+dux*fryj*pmi_over_rhoj
      curl3z_b(j)= curl3z_b(j)+duy*frxj*pmi_over_rhoj

      return
      end
